//http://seta43.hol.es/electro.html
//xsetaseta@gmail.com
//Libreria RF24master J. Coliz <maniacbug@ymail.com>
// Sensores temperatura   
//12/03/2018

#define DIGIE  3  //Seleccin pin de numero de sensor

#include <OneWire.h>
OneWire ds(2); // pin utilizado para el bus Onewire
int Otemperatura;


#include <SPI.h> 
#include <nRF24L01.h>
#include <RF24.h>

#define CE 8
#define CSN 7

RF24 radio(CE, CSN);

const uint64_t tuberia = 0xE8E8F0F0E1LL;
byte dato[10];

bool done;
int time1,time2;
int z;
byte CNUMERO;

void setup() 
{
  pinMode(DIGIE, INPUT);
  if(digitalRead(DIGIE))
    CNUMERO=1;
   else
    CNUMERO=2;
    
  Serial.begin(9600);
  Serial.print("_Sensor_N"); Serial.println(CNUMERO);
  radio.begin();
  radio.setChannel(50);  
  radio.openReadingPipe(1, tuberia); 
  radio.startListening();
  time1=9000; 
}


void loop(void)
{ 
  delay(1);
  
  time1++;

  if(time1>10000)
  {
     time1=0;
     if(0==getTemp()) getTemp();
     Serial.print(Otemperatura);
     Serial.println(" Centigradosx10");
  }
  
  
  while(radio.available()) 
  {
    radio.read(dato, 7);                   
    done=1;  
  }
  
  if (done)
  { 
    if( dato[0] == 0)
      {Serial.print("TX_base->"); Serial.println(dato[1]); }
    if( dato[1] != CNUMERO) goto salto;
    Serial.println("Temp?");
    radio.stopListening();
    radio.openWritingPipe(tuberia);
    delay(100);

    dato[0]=CNUMERO;  //Numero del sensor  
    dato[1]=0;  // a Base
    dato[2]=1;  //  1-Temperatura
    dato[3]=34;  // Dato1
    dato[4]=43;  // Dato2
    dato[3]=Otemperatura >> 8;
    dato[4]=Otemperatura & 0xFF;
    
    enviarS();
    delay(100);

salto:
    radio.openReadingPipe(1, tuberia); 
    radio.startListening();  

    done=0;
  }
    
}


void enviarS()
{
  radio.write(dato, 7); 
  delay(10);
}




//______________________________________________________
//ds18B20

int getTemp()
{
  byte data[12];
  byte addr[8];
  int z;
  long  temp;
 // byte decimal;


  if ( !ds.search(addr))   { ds.reset_search(); return 0; }
  if ( OneWire::crc8( addr, 7) != addr[7]) ;// { SERIECONSOLA.println(F("CRC is not valid!")); return -1; }
  if ( addr[0] != 0x10 && addr[0] != 0x28) ;// { SERIECONSOLA.print(F("Device is not recognized")); return -1; }

  ds.reset();  ds.select(addr);  ds.write(0x4E);         
  ds.write(0x4B);    
  ds.write(0x46);    
  ds.write(0x7F);    // 12-bit sampling resolution (default)
  //ds.write(0x5F);    // 11-bit
  //ds.write(0x3F);    // 10-bit
  //ds.write(0x1F);    // 9-bit
  // delay(500); 

  ds.reset();  ds.select(addr);  ds.write(0x44,1); // start conversion, with parasite power on at the end
  delay(750);  

  ds.reset();  ds.select(addr);  ds.write(0xBE); // Read Scratchpad
  for ( z = 0; z < 9; z++) data[z] = ds.read();
    
  z = (data[1] << 8) | data[0];
  temp=z;
  temp=(temp*625)/1000;  
  Otemperatura=temp;
  return 1;  
}
