//http://seta43.hol.es/electro.html
//xsetaseta@gmail.com 
//12/03/2018
//Temperatura Base
//OLED version texto

#include "olex.h"
#include <Wire.h>


#include <SPI.h> 
#include <nRF24L01.h>
#include <RF24.h>

#define CE 8
#define CSN 7

RF24 radio(CE, CSN);

const uint64_t tuberia = 0xE8E8F0F0E1LL;

bool done;
byte dato[10];

byte sensor;
int time1,time2;
int temperatura;
int z;
int decimal;
char bufferTemp[10];

void setup() 
{
  Wire.begin();
  OleInit();
  xclearDisplay();  
  ModeFont=0;   xStringAT(0,0,"Temperatura");
  time1=4000;
  
  Serial.begin(9600);
  Serial.println("__Base Sensores__");
  radio.begin(); 
  radio.setChannel(50); 	
  radio.openWritingPipe(tuberia);
  sensor=1; 
  
}

void loop() 
{
  delay(1);
  time1++;
  time2++;

  if(time1>4000)
  {
    time1=0;
    radio.stopListening();
    radio.openWritingPipe(tuberia);
    delay(100);
   
    dato[0]=0;  // Canal 0 de maestro
    if(sensor==1)
      sensor=2;
     else
      sensor=1;
    
    if(sensor==1)
          xStringAT(0,3,"S1        "); 
       else
          xStringAT(0,6,"S2        ");
          
    dato[1]=sensor;    //numero de sensor
    enviarS();
    delay(50);
    radio.openReadingPipe(1, tuberia); 
    radio.startListening();  
  } 


  while(radio.available()) 
  {
    radio.read(dato, 7);               
    done=1;  
  }

  if (done)
  { 
    Serial.print("SENSOR_");    Serial.print(dato[0]); 
  //  Serial.print(" Respuesta_"); Serial.print(dato[2]);
  //  Serial.print(" Dato1_"); Serial.print(dato[3]); 
  //  Serial.print(" Dato2_"); Serial.print(dato[4]);
    Serial.print("   ");
    temperatura=dato[3] << 8;
    temperatura=temperatura | dato[4];
        
    decimal= temperatura % 10;
    if (decimal<0) decimal*=-1;
    sprintf(bufferTemp,"S%d %d,%d%cC ",dato[0],temperatura/10,decimal,127);
    Serial.println(bufferTemp); 
    ModeFont=2;
    if(dato[0]==1)
          xStringAT(0,3,bufferTemp); 
       else
          xStringAT(0,6,bufferTemp);
    done=0;
  }  
}



void enviarS()
{
  radio.write(dato, 7); 
  delay(10);
}

